--[[
  * Wykkyd's [ War Tools ]
  * Sponsored & Supported by: Mostly Harmless (mostly-harmless-guild.com)
  * Author: Wykkyd, aka Wykkyd Gaming (wykkyd.gaming@gmail.com)
  * Special Thanks To: Zenimax Online Studios & Bethesda for The Elder Scrolls Online
]]--

WYK_WarTools = {}
WYK_WarTools._v = {}
WYK_WarTools._v.major	= 1
WYK_WarTools._v.monthly	= 5
WYK_WarTools._v.daily 	= 2
WYK_WarTools._v.minor 	= 1
WYK_WarTools.Version 	= WYK_WarTools._v.major
	.."."..WYK_WarTools._v.monthly
	.."."..WYK_WarTools._v.daily
	.."."..WYK_WarTools._v.minor
	
WYK_WarTools.MAJOR 		= WYK_WarTools._v.major.."."..WYK_WarTools._v.monthly.."."..WYK_WarTools._v.daily
WYK_WarTools.MINOR 		= WYK_WarTools._v.minor
WYK_WarTools.Name			= "wykkydsWarTools"
WYK_WarTools.DisplayName  	= "Wykkyd's War Tools"
WYK_WarTools.SettingsName 	= "|cFF2222Wykkyd's|r Config"

WYK_WarTools.SavedVariableVersion = 3
WYK_WarTools.Player = GetUnitName("player"):gsub("%^%a+","")

WYK_WarTools.Settings = {}
WYK_WarTools.GlobalSettings = {}

WYK_WarTools.CommandLine = function(text)
	if not text or text == "" or text == "help" then
		d("[WarTools] accepted commands:")
		d("[WarTools] /wt  << shows help")
		d("[WarTools] /wt show << shows the hidden window")
		d("[WarTools] /wt hide << shows the displayed window")
		d("[WarTools] /warcommand << toggles command, if group lead")
		return
	end
	
	if string.find(text, "show") then
		local t = text:gsub("show ","")
		WYK_WarTools.UserInterface.StrategyFrame.Show()
	end
	
	if string.find(text, "hide") then
		local t = text:gsub("hide ","")
		WYK_WarTools.UserInterface.StrategyFrame.Hide(false)
	end
end

WYK_WarTools.LoadGlobals = function( self )
	self.channel = {}
	self.Prefix = {}
	self.Prefix.Commander = "[WarCommand]"
	self.Prefix.Helper = "[WarHelper]"
	self.Prefix.Tools = "[WarTools]"
	self.Prefix.Default = "[WT]"
	self.Mode = {}
	self.Mode.Commander = false
	self.Mode.HelpBot = false
	self.CyrodiilEventsRegistered = false
end

WYK_WarTools.LoadLists = function( self )
	self.Lists = {}
	self.Lists.Alliances = { [0] = nil, [1] = "Aldmeri Dominion", [2] = "Ebonheart Pact", [3] = "Daggerfall Covenant", }
	self.Lists.AllianceColors = { [0] = nil, [1] = "yellow", [2] = "red", [3] = "blue", }
	self.Lists.AllianceFonts = { [0] = {0.3,0.3,0.3,1}, [1] = {1,1,0.3,1}, [2] = {1,0.3,0.3,1}, [3] = {.5, .65, .9, 1}, }
	self.Lists.AllianceHighlights = { [0] = {0.1,0.1,0.1,1}, [1] = {0.6,0.6,0.1,1}, [2] = {0.6,0.1,0.1,1}, [3] = {0.1,0.1,0.6,1}, }
	self.Lists.AllianceBorderHighlights = { [0] = {0.1,0.1,0.1,1}, [1] = {0.8,0.8,0.1,1}, [2] = {0.8,0.1,0.1,1}, [3] = {0.1,0.1,0.8,1}, }
	self.Lists.AllianceBackdropColors = { [0] = nil, [1] = {0.25,0.25,0.1,1}, [2] = {0.25,0.1,0.1,1}, [3] = {0.1,0.1,0.25,1}, }

	self.Lists.Images = {}
	self.Lists.Images.Mines = {}
	self.Lists.Images.Mines[0] = "/esoui/art/ava/ava_keepstatus_icon_ore_neutral.dds"
	self.Lists.Images.Mines[1] = "/esoui/art/ava/ava_keepstatus_icon_ore_aldmeri.dds"
	self.Lists.Images.Mines[2] = "/esoui/art/ava/ava_keepstatus_icon_ore_ebonheart.dds"
	self.Lists.Images.Mines[3] = "/esoui/art/ava/ava_keepstatus_icon_ore_daggerfall.dds"
	self.Lists.Images.Mills = {}
	self.Lists.Images.Mills[0] = "/esoui/art/ava/ava_keepstatus_icon_wood_neutral.dds"
	self.Lists.Images.Mills[1] = "/esoui/art/ava/ava_keepstatus_icon_wood_aldmeri.dds"
	self.Lists.Images.Mills[2] = "/esoui/art/ava/ava_keepstatus_icon_wood_ebonheart.dds"
	self.Lists.Images.Mills[3] = "/esoui/art/ava/ava_keepstatus_icon_wood_daggerfall.dds"
	self.Lists.Images.Farms = {}
	self.Lists.Images.Farms[0] = "/esoui/art/ava/ava_keepstatus_icon_food_neutral.dds"
	self.Lists.Images.Farms[1] = "/esoui/art/ava/ava_keepstatus_icon_food_aldmeri.dds"
	self.Lists.Images.Farms[2] = "/esoui/art/ava/ava_keepstatus_icon_food_ebonheart.dds"
	self.Lists.Images.Farms[3] = "/esoui/art/ava/ava_keepstatus_icon_food_daggerfall.dds"
	self.Lists.Images.Keeps = {}
	self.Lists.Images.Keeps[0] = "/esoui/art/mappins/ava_largekeep_neutral.dds"
	self.Lists.Images.Keeps[1] = "/esoui/art/mappins/ava_largekeep_aldmeri.dds"
	self.Lists.Images.Keeps[2] = "/esoui/art/mappins/ava_largekeep_ebonheart.dds"
	self.Lists.Images.Keeps[3] = "/esoui/art/mappins/ava_largekeep_daggerfall.dds"
	self.Lists.Images.Keeps[10] = "/esoui/art/mappins/ava_largekeep_neutral_underattack.dds"
	self.Lists.Images.Keeps[11] = "/esoui/art/mappins/ava_largekeep_aldmeri_underattack.dds"
	self.Lists.Images.Keeps[12] = "/esoui/art/mappins/ava_largekeep_ebonheart_underattack.dds"
	self.Lists.Images.Keeps[13] = "/esoui/art/mappins/ava_largekeep_daggerfall_underattack.dds"
	self.Lists.Images.Outposts = {}
	self.Lists.Images.Outposts[0] = "/esoui/art/mappins/ava_outpost_neutral.dds"
	self.Lists.Images.Outposts[1] = "/esoui/art/mappins/ava_outpost_aldmeri.dds"
	self.Lists.Images.Outposts[2] = "/esoui/art/mappins/ava_outpost_ebonheart.dds"
	self.Lists.Images.Outposts[3] = "/esoui/art/mappins/ava_outpost_daggerfall.dds"
	self.Lists.Images.Scrolls = {}
	self.Lists.Images.Scrolls[0] = "/esoui/art/campaign/campaignbonus_scrollicon.dds"
	self.Lists.Images.Scrolls[1] = "/esoui/art/campaign/overview_scrollicon_aldmeri.dds"
	self.Lists.Images.Scrolls[2] = "/esoui/art/campaign/overview_scrollicon_ebonheart.dds"
	self.Lists.Images.Scrolls[3] = "/esoui/art/campaign/overview_scrollicon_daggefall.dds"

	self.Lists.Images.AllianceIcons = {
		[1] = "/esoui/art/campaign/overview_allianceicon_aldmeri.dds",
		[2] = "/esoui/art/campaign/overview_allianceicon_ebonheart.dds",
		[3] = "/esoui/art/campaign/overview_allianceicon_daggefall.dds"
	}
	self.Lists.Images.Overview = {
		[1] = {
			[1] = "/esoui/art/campaign/overview_keepicon_aldmeri.dds",
			[2] = "/esoui/art/campaign/overview_outposticon_aldmeri.dds",
			[3] = "/esoui/art/campaign/overview_resourcesicon_aldmeri.dds",
			[4] = "/esoui/art/campaign/overview_scrollicon_aldmeri.dds"
		},
		[2] = {
			[1] = "/esoui/art/campaign/overview_keepicon_ebonheart.dds",
			[2] = "/esoui/art/campaign/overview_outposticon_ebonheart.dds",
			[3] = "/esoui/art/campaign/overview_resourcesicon_ebonheart.dds",
			[4] = "/esoui/art/campaign/overview_scrollicon_ebonheart.dds"
		},
		[3] = {
			[1] = "/esoui/art/campaign/overview_keepicon_daggefall.dds",
			[2] = "/esoui/art/campaign/overview_outposticon_daggefall.dds",
			[3] = "/esoui/art/campaign/overview_resourcesicon_daggefall.dds",
			[4] = "/esoui/art/campaign/overview_scrollicon_daggefall.dds"
		},
	}
	self.Lists.AllianceKeeps = {
		[1] = "Castle *",
		[2] = "* Keep",
		[3] = "Fort *",
		[4] = "* Outpost",
	}
	self.Lists.Resources = {
		[0] = "Self",
		[1] = "Title",
		[2] = "Keep",
		[3] = "Mine",
		[4] = "Farm",
		[5] = "Lumbermill",
	}
	self.Lists.AllianceObjectives = {
		[0] = nil,
		[1] = {
			[1] = { key = "Alessia", displayName = "Castle Alessia" },
			[2] = { key = "Black Boot", displayName = "Castle Black Boot" },
			[3] = { key = "Bloodmayne", displayName = "Castle Bloodmayne" },
			[4] = { key = "Brindle", displayName = "Castle Brindle" },
			[5] = { key = "Faregyl", displayName = "Castle Faregyl" },
			[6] = { key = "Roebeck", displayName = "Castle Roebeck" },
			[7] = { key = "Nikel", displayName = "Nikel Outpost" },
			[8] = { 
				[1] = { key = "Elder Scroll of Altadoon", displayName = "Elder Scroll of Altadoon" },
				[2] = { key = "Elder Scroll of Mnem", displayName = "Elder Scroll of Mnem" },
			}
		},
		[2] = {
			[1] = { key = "Arrius", displayName = "Arrius Keep" },
			[2] = { key = "Blue Road", displayName = "Blue Road Keep" },
			[3] = { key = "Chalman", displayName = "Chalman Keep" },
			[4] = { key = "Drakelowe", displayName = "Drakelowe Keep" },
			[5] = { key = "Farragut", displayName = "Farragut Keep" },
			[6] = { key = "Kingscrest", displayName = "Kingscrest Keep" },
			[7] = { key = "Sejanus", displayName = "Sejanus Outpost" },
			[8] = { 
				[1] = { key = "Elder Scroll of Ghartok", displayName = "Elder Scroll of Ghartok" },
				[2] = { key = "Elder Scroll of Chim", displayName = "Elder Scroll of Chim" },
			}
		},
		[3] = {
			[1] = { key = "Aleswell", displayName = "Fort Aleswell" },
			[2] = { key = "Ash", displayName = "Fort Ash" },
			[3] = { key = "Dragonclaw", displayName = "Fort Dragonclaw" },
			[4] = { key = "Glademist", displayName = "Fort Glademist" },
			[5] = { key = "Rayles", displayName = "Fort Rayles" },
			[6] = { key = "Warden", displayName = "Fort Warden" },
			[7] = { key = "Bleaker's", displayName = "Bleaker's Outpost" },
			[8] = { 
				[1] = { key = "Elder Scroll of Ni-Mohk", displayName = "Elder Scroll of Ni-Mohk" },
				[2] = { key = "Elder Scroll of Alma Ruma", displayName = "Elder Scroll of Alma Ruma" },
			}
		},
	}
	for a = 1, 3, 1 do
		for k = 1, 6, 1 do
			local dn = self.Lists.AllianceKeeps[a]:gsub("*", self.Lists.AllianceObjectives[a][k].key)
			self.Lists.AllianceObjectives[a][k].displayName = dn
		end
		local dn = self.Lists.AllianceKeeps[4]:gsub("*", self.Lists.AllianceObjectives[a][7].key)
		self.Lists.AllianceObjectives[a][7].displayName = dn
	end

	self.Lists.PinTypes = {
		[MAP_PIN_TYPE_AGGRO]	= "MAP_PIN_TYPE_AGGRO",
		[MAP_PIN_TYPE_ALDMERI_VS_DAGGERFALL_LARGE]	= "MAP_PIN_TYPE_ALDMERI_VS_DAGGERFALL_LARGE",
		[MAP_PIN_TYPE_ALDMERI_VS_DAGGERFALL_MEDIUM]	= "MAP_PIN_TYPE_ALDMERI_VS_DAGGERFALL_MEDIUM",
		[MAP_PIN_TYPE_ALDMERI_VS_DAGGERFALL_SMALL]	= "MAP_PIN_TYPE_ALDMERI_VS_DAGGERFALL_SMALL",
		[MAP_PIN_TYPE_ALDMERI_VS_EBONHEART_LARGE]	= "MAP_PIN_TYPE_ALDMERI_VS_EBONHEART_LARGE",
		[MAP_PIN_TYPE_ALDMERI_VS_EBONHEART_MEDIUM]	= "MAP_PIN_TYPE_ALDMERI_VS_EBONHEART_MEDIUM",
		[MAP_PIN_TYPE_ALDMERI_VS_EBONHEART_SMALL]	= "MAP_PIN_TYPE_ALDMERI_VS_EBONHEART_SMALL",
		[MAP_PIN_TYPE_ARTIFACT_ALDMERI_DEFENSIVE]	= "MAP_PIN_TYPE_ARTIFACT_ALDMERI_DEFENSIVE",
		[MAP_PIN_TYPE_ARTIFACT_ALDMERI_OFFENSIVE]	= "MAP_PIN_TYPE_ARTIFACT_ALDMERI_OFFENSIVE",
		[MAP_PIN_TYPE_ARTIFACT_DAGGERFALL_DEFENSIVE]	= "MAP_PIN_TYPE_ARTIFACT_DAGGERFALL_DEFENSIVE",
		[MAP_PIN_TYPE_ARTIFACT_DAGGERFALL_OFFENSIVE]	= "MAP_PIN_TYPE_ARTIFACT_DAGGERFALL_OFFENSIVE",
		[MAP_PIN_TYPE_ARTIFACT_EBONHEART_DEFENSIVE]	= "MAP_PIN_TYPE_ARTIFACT_EBONHEART_DEFENSIVE",
		[MAP_PIN_TYPE_ARTIFACT_EBONHEART_OFFENSIVE]	= "MAP_PIN_TYPE_ARTIFACT_EBONHEART_OFFENSIVE",
		[MAP_PIN_TYPE_ARTIFACT_GATE_CLOSED_ALDMERI_DOMINION]	= "MAP_PIN_TYPE_ARTIFACT_GATE_CLOSED_ALDMERI_DOMINION",
		[MAP_PIN_TYPE_ARTIFACT_GATE_CLOSED_DAGGERFALL_COVENANT]	= "MAP_PIN_TYPE_ARTIFACT_GATE_CLOSED_DAGGERFALL_COVENANT",
		[MAP_PIN_TYPE_ARTIFACT_GATE_CLOSED_EBONHEART_PACT]	= "MAP_PIN_TYPE_ARTIFACT_GATE_CLOSED_EBONHEART_PACT",
		[MAP_PIN_TYPE_ARTIFACT_GATE_OPEN_ALDMERI_DOMINION]	= "MAP_PIN_TYPE_ARTIFACT_GATE_OPEN_ALDMERI_DOMINION",
		[MAP_PIN_TYPE_ARTIFACT_GATE_OPEN_DAGGERFALL_COVENANT]	= "MAP_PIN_TYPE_ARTIFACT_GATE_OPEN_DAGGERFALL_COVENANT",
		[MAP_PIN_TYPE_ARTIFACT_GATE_OPEN_EBONHEART_PACT]	= "MAP_PIN_TYPE_ARTIFACT_GATE_OPEN_EBONHEART_PACT",
		[MAP_PIN_TYPE_ARTIFACT_KEEP_ALDMERI_DOMINION]	= "MAP_PIN_TYPE_ARTIFACT_KEEP_ALDMERI_DOMINION",
		[MAP_PIN_TYPE_ARTIFACT_KEEP_DAGGERFALL_COVENANT]	= "MAP_PIN_TYPE_ARTIFACT_KEEP_DAGGERFALL_COVENANT",
		[MAP_PIN_TYPE_ARTIFACT_KEEP_EBONHEART_PACT]	= "MAP_PIN_TYPE_ARTIFACT_KEEP_EBONHEART_PACT",
		[MAP_PIN_TYPE_ARTIFACT_RETURN_ALDMERI]	= "MAP_PIN_TYPE_ARTIFACT_RETURN_ALDMERI",
		[MAP_PIN_TYPE_ARTIFACT_RETURN_DAGGERFALL]	= "MAP_PIN_TYPE_ARTIFACT_RETURN_DAGGERFALL",
		[MAP_PIN_TYPE_ARTIFACT_RETURN_EBONHEART]	= "MAP_PIN_TYPE_ARTIFACT_RETURN_EBONHEART",
		[MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION]	= "MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION",
		[MAP_PIN_TYPE_ASSISTED_QUEST_ENDING]	= "MAP_PIN_TYPE_ASSISTED_QUEST_ENDING",
		[MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION]	= "MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION",
		[MAP_PIN_TYPE_BALL_ALDMERI_DOMINION]	= "MAP_PIN_TYPE_BALL_ALDMERI_DOMINION",
		[MAP_PIN_TYPE_BALL_DAGGERFALL_COVENANT]	= "MAP_PIN_TYPE_BALL_DAGGERFALL_COVENANT",
		[MAP_PIN_TYPE_BALL_EBONHEART_PACT]	= "MAP_PIN_TYPE_BALL_EBONHEART_PACT",
		[MAP_PIN_TYPE_BALL_NEUTRAL]	= "MAP_PIN_TYPE_BALL_NEUTRAL",
		[MAP_PIN_TYPE_BORDER_KEEP_ALDMERI_DOMINION]	= "MAP_PIN_TYPE_BORDER_KEEP_ALDMERI_DOMINION",
		[MAP_PIN_TYPE_BORDER_KEEP_DAGGERFALL_COVENANT]	= "MAP_PIN_TYPE_BORDER_KEEP_DAGGERFALL_COVENANT",
		[MAP_PIN_TYPE_BORDER_KEEP_EBONHEART_PACT]	= "MAP_PIN_TYPE_BORDER_KEEP_EBONHEART_PACT",
		[MAP_PIN_TYPE_CAPTURE_FLAG_ALDMERI_DOMINION]	= "MAP_PIN_TYPE_CAPTURE_FLAG_ALDMERI_DOMINION",
		[MAP_PIN_TYPE_CAPTURE_FLAG_DAGGERFALL_COVENANT]	= "MAP_PIN_TYPE_CAPTURE_FLAG_DAGGERFALL_COVENANT",
		[MAP_PIN_TYPE_CAPTURE_FLAG_EBONHEART_PACT]	= "MAP_PIN_TYPE_CAPTURE_FLAG_EBONHEART_PACT",
		[MAP_PIN_TYPE_CAPTURE_FLAG_NEUTRAL]	= "MAP_PIN_TYPE_CAPTURE_FLAG_NEUTRAL",
		[MAP_PIN_TYPE_EBONHEART_VS_DAGGERFALL_LARGE]	= "MAP_PIN_TYPE_EBONHEART_VS_DAGGERFALL_LARGE",
		[MAP_PIN_TYPE_EBONHEART_VS_DAGGERFALL_MEDIUM]	= "MAP_PIN_TYPE_EBONHEART_VS_DAGGERFALL_MEDIUM",
		[MAP_PIN_TYPE_EBONHEART_VS_DAGGERFALL_SMALL]	= "MAP_PIN_TYPE_EBONHEART_VS_DAGGERFALL_SMALL",
		[MAP_PIN_TYPE_FARM_ALDMERI_DOMINION]	= "MAP_PIN_TYPE_FARM_ALDMERI_DOMINION",
		[MAP_PIN_TYPE_FARM_DAGGERFALL_COVENANT]	= "MAP_PIN_TYPE_FARM_DAGGERFALL_COVENANT",
		[MAP_PIN_TYPE_FARM_EBONHEART_PACT]	= "MAP_PIN_TYPE_FARM_EBONHEART_PACT",
		[MAP_PIN_TYPE_FARM_NEUTRAL]	= "MAP_PIN_TYPE_FARM_NEUTRAL",
		[MAP_PIN_TYPE_FAST_TRAVEL_BORDER_KEEP_ACCESSIBLE]	= "MAP_PIN_TYPE_FAST_TRAVEL_BORDER_KEEP_ACCESSIBLE",
		[MAP_PIN_TYPE_FAST_TRAVEL_KEEP_ACCESSIBLE]	= "MAP_PIN_TYPE_FAST_TRAVEL_KEEP_ACCESSIBLE",
		[MAP_PIN_TYPE_FAST_TRAVEL_OUTPOST_ACCESSIBLE]	= "MAP_PIN_TYPE_FAST_TRAVEL_OUTPOST_ACCESSIBLE",
		[MAP_PIN_TYPE_FAST_TRAVEL_WAYSHRINE]	= "MAP_PIN_TYPE_FAST_TRAVEL_WAYSHRINE",
		[MAP_PIN_TYPE_FAST_TRAVEL_WAYSHRINE_CURRENT_LOC]	= "MAP_PIN_TYPE_FAST_TRAVEL_WAYSHRINE_CURRENT_LOC",
		[MAP_PIN_TYPE_FAST_TRAVEL_WAYSHRINE_UNDISCOVERED]	= "MAP_PIN_TYPE_FAST_TRAVEL_WAYSHRINE_UNDISCOVERED",
		[MAP_PIN_TYPE_FLAG_ALDMERI_DOMINION]	= "MAP_PIN_TYPE_FLAG_ALDMERI_DOMINION",
		[MAP_PIN_TYPE_FLAG_BASE_ALDMERI_DOMINION]	= "MAP_PIN_TYPE_FLAG_BASE_ALDMERI_DOMINION",
		[MAP_PIN_TYPE_FLAG_BASE_DAGGERFALL_COVENANT]	= "MAP_PIN_TYPE_FLAG_BASE_DAGGERFALL_COVENANT",
		[MAP_PIN_TYPE_FLAG_BASE_EBONHEART_PACT]	= "MAP_PIN_TYPE_FLAG_BASE_EBONHEART_PACT",
		[MAP_PIN_TYPE_FLAG_BASE_NEUTRAL]	= "MAP_PIN_TYPE_FLAG_BASE_NEUTRAL",
		[MAP_PIN_TYPE_FLAG_DAGGERFALL_COVENANT]	= "MAP_PIN_TYPE_FLAG_DAGGERFALL_COVENANT",
		[MAP_PIN_TYPE_FLAG_EBONHEART_PACT]	= "MAP_PIN_TYPE_FLAG_EBONHEART_PACT",
		[MAP_PIN_TYPE_FLAG_NEUTRAL]	= "MAP_PIN_TYPE_FLAG_NEUTRAL",
		[MAP_PIN_TYPE_FORWARD_CAMP_ACCESSIBLE]	= "MAP_PIN_TYPE_FORWARD_CAMP_ACCESSIBLE",
		[MAP_PIN_TYPE_FORWARD_CAMP_ALDMERI_DOMINION]	= "MAP_PIN_TYPE_FORWARD_CAMP_ALDMERI_DOMINION",
		[MAP_PIN_TYPE_FORWARD_CAMP_DAGGERFALL_COVENANT]	= "MAP_PIN_TYPE_FORWARD_CAMP_DAGGERFALL_COVENANT",
		[MAP_PIN_TYPE_FORWARD_CAMP_EBONHEART_PACT]	= "MAP_PIN_TYPE_FORWARD_CAMP_EBONHEART_PACT",
		[MAP_PIN_TYPE_GROUP]	= "MAP_PIN_TYPE_GROUP",
		[MAP_PIN_TYPE_HALF_CAPTURE_FLAG_ALDMERI_DOMINION]	= "MAP_PIN_TYPE_HALF_CAPTURE_FLAG_ALDMERI_DOMINION",
		[MAP_PIN_TYPE_HALF_CAPTURE_FLAG_DAGGERFALL_COVENANT]	= "MAP_PIN_TYPE_HALF_CAPTURE_FLAG_DAGGERFALL_COVENANT",
		[MAP_PIN_TYPE_HALF_CAPTURE_FLAG_EBONHEART_PACT]	= "MAP_PIN_TYPE_HALF_CAPTURE_FLAG_EBONHEART_PACT",
		[MAP_PIN_TYPE_HARVEST_NODE]	= "MAP_PIN_TYPE_HARVEST_NODE",
		[MAP_PIN_TYPE_KEEP_ALDMERI_DOMINION]	= "MAP_PIN_TYPE_KEEP_ALDMERI_DOMINION",
		[MAP_PIN_TYPE_KEEP_ATTACKED_LARGE]	= "MAP_PIN_TYPE_KEEP_ATTACKED_LARGE",
		[MAP_PIN_TYPE_KEEP_ATTACKED_SMALL]	= "MAP_PIN_TYPE_KEEP_ATTACKED_SMALL",
		[MAP_PIN_TYPE_KEEP_DAGGERFALL_COVENANT]	= "MAP_PIN_TYPE_KEEP_DAGGERFALL_COVENANT",
		[MAP_PIN_TYPE_KEEP_EBONHEART_PACT]	= "MAP_PIN_TYPE_KEEP_EBONHEART_PACT",
		[MAP_PIN_TYPE_KEEP_GRAVEYARD_ACCESSIBLE]	= "MAP_PIN_TYPE_KEEP_GRAVEYARD_ACCESSIBLE",
		[MAP_PIN_TYPE_KEEP_NEUTRAL]	= "MAP_PIN_TYPE_KEEP_NEUTRAL",
		[MAP_PIN_TYPE_LOCATION]	= "MAP_PIN_TYPE_LOCATION",
		[MAP_PIN_TYPE_MILL_ALDMERI_DOMINION]	= "MAP_PIN_TYPE_MILL_ALDMERI_DOMINION",
		[MAP_PIN_TYPE_MILL_DAGGERFALL_COVENANT]	= "MAP_PIN_TYPE_MILL_DAGGERFALL_COVENANT",
		[MAP_PIN_TYPE_MILL_EBONHEART_PACT]	= "MAP_PIN_TYPE_MILL_EBONHEART_PACT",
		[MAP_PIN_TYPE_MILL_NEUTRAL]	= "MAP_PIN_TYPE_MILL_NEUTRAL",
		[MAP_PIN_TYPE_MINE_ALDMERI_DOMINION]	= "MAP_PIN_TYPE_MINE_ALDMERI_DOMINION",
		[MAP_PIN_TYPE_MINE_DAGGERFALL_COVENANT]	= "MAP_PIN_TYPE_MINE_DAGGERFALL_COVENANT",
		[MAP_PIN_TYPE_MINE_EBONHEART_PACT]	= "MAP_PIN_TYPE_MINE_EBONHEART_PACT",
		[MAP_PIN_TYPE_MINE_NEUTRAL]	= "MAP_PIN_TYPE_MINE_NEUTRAL",
		[MAP_PIN_TYPE_NPC_FOLLOWER]	= "MAP_PIN_TYPE_NPC_FOLLOWER",
		[MAP_PIN_TYPE_OUTPOST_ALDMERI_DOMINION]	= "MAP_PIN_TYPE_OUTPOST_ALDMERI_DOMINION",
		[MAP_PIN_TYPE_OUTPOST_DAGGERFALL_COVENANT]	= "MAP_PIN_TYPE_OUTPOST_DAGGERFALL_COVENANT",
		[MAP_PIN_TYPE_OUTPOST_EBONHEART_PACT]	= "MAP_PIN_TYPE_OUTPOST_EBONHEART_PACT",
		[MAP_PIN_TYPE_OUTPOST_NEUTRAL]	= "MAP_PIN_TYPE_OUTPOST_NEUTRAL",
		[MAP_PIN_TYPE_PING]	= "MAP_PIN_TYPE_PING",
		[MAP_PIN_TYPE_PIN_GLOW]	= "MAP_PIN_TYPE_PIN_GLOW",
		[MAP_PIN_TYPE_PLAYER]	= "MAP_PIN_TYPE_PLAYER",
		[MAP_PIN_TYPE_PLAYER_CAMERA]	= "MAP_PIN_TYPE_PLAYER_CAMERA",
		[MAP_PIN_TYPE_POI_COMPLETE]	= "MAP_PIN_TYPE_POI_COMPLETE",
		[MAP_PIN_TYPE_POI_SEEN]	= "MAP_PIN_TYPE_POI_SEEN",
		[MAP_PIN_TYPE_QUEST_COMPLETE]	= "MAP_PIN_TYPE_QUEST_COMPLETE",
		[MAP_PIN_TYPE_QUEST_INTERACT]	= "MAP_PIN_TYPE_QUEST_INTERACT",
		[MAP_PIN_TYPE_QUEST_OFFER]	= "MAP_PIN_TYPE_QUEST_OFFER",
		[MAP_PIN_TYPE_QUEST_TALK_TO]	= "MAP_PIN_TYPE_QUEST_TALK_TO",
		[MAP_PIN_TYPE_RALLY_POINT]	= "MAP_PIN_TYPE_RALLY_POINT",
		[MAP_PIN_TYPE_RETURN_ALDMERI_DOMINION]	= "MAP_PIN_TYPE_RETURN_ALDMERI_DOMINION",
		[MAP_PIN_TYPE_RETURN_DAGGERFALL_COVENANT]	= "MAP_PIN_TYPE_RETURN_DAGGERFALL_COVENANT",
		[MAP_PIN_TYPE_RETURN_EBONHEART_PACT]	= "MAP_PIN_TYPE_RETURN_EBONHEART_PACT",
		[MAP_PIN_TYPE_RETURN_NEUTRAL]	= "MAP_PIN_TYPE_RETURN_NEUTRAL",
		[MAP_PIN_TYPE_TRACKED_QUEST_CONDITION]	= "MAP_PIN_TYPE_TRACKED_QUEST_CONDITION",
		[MAP_PIN_TYPE_TRACKED_QUEST_ENDING]	= "MAP_PIN_TYPE_TRACKED_QUEST_ENDING",
		[MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION]	= "MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION",
		[MAP_PIN_TYPE_TRAINER]	= "MAP_PIN_TYPE_TRAINER",
		[MAP_PIN_TYPE_TRI_BATTLE_LARGE]	= "MAP_PIN_TYPE_TRI_BATTLE_LARGE",
		[MAP_PIN_TYPE_TRI_BATTLE_MEDIUM]	= "MAP_PIN_TYPE_TRI_BATTLE_MEDIUM",
		[MAP_PIN_TYPE_TRI_BATTLE_SMALL]	= "MAP_PIN_TYPE_TRI_BATTLE_SMALL",
		[MAP_PIN_TYPE_VENDOR]	= "MAP_PIN_TYPE_VENDOR",
	}
end

WYK_WarTools.LoadSavedVariables = function( self )
	if wykkydsWarToolsGlobal == nil then wykkydsWarToolsGlobal = {} end
	if wykkydsWarToolsGlobal[self.SavedVariableVersion] == nil then wykkydsWarToolsGlobal[self.SavedVariableVersion] = {} end
	if wykkydsWarToolsGlobal[self.SavedVariableVersion][self.Player] == nil then wykkydsWarToolsGlobal[self.SavedVariableVersion][self.Player] = {} end
	if wykkydsWarToolsGlobal[self.SavedVariableVersion]["global"] == nil then wykkydsWarToolsGlobal[self.SavedVariableVersion]["global"] = {} end
	WYK_WarTools.Settings = wykkydsWarToolsGlobal[self.SavedVariableVersion][self.Player]
	WYK_WarTools.GlobalSettings = wykkydsWarToolsGlobal[self.SavedVariableVersion]["global"]
	
	if WYK_WarTools.Settings["UI"] == nil then WYK_WarTools.Settings["UI"] = {
		Moveable=true, Hidden=false, ShiftX=0, ShiftY=0,
	} end
	
	WYK_WarTools:LoadGlobals()
	WYK_WarTools:LoadLists()
end

WYK_WarTools.LoadSettingsMenu = function( self )
	self:CreateMenu()
	self:AddMenuAddonLabel()
	
	self:AddMenuButton("Click To Center Window!", nil, function()
		if WYK_WarTools_StrategyUI ~= nil then
			WYK_WarTools_StrategyUI:ClearAnchors()
			WYK_WarTools_StrategyUI:SetAnchor(CENTER, GuiRoot, CENTER, 0, 0)
			WYK_WarTools_StrategyUI:SetMoveState(true)
			WYK_WarTools_StrategyUI:SetFrameCoords()
		end
	end)
	self:AddMenuSlider("Window Scale", nil, 60, 120, 1, function()
		return self:GetOrDefault( 1, self.Settings["UIScale"] ) * 100
	end, function(val)
		self.Settings["UIScale"] = (val / 100)
		if WYK_WarTools_StrategyUI ~= nil then
			WYK_WarTools_StrategyUI:SetScale( val / 100 )
		end
	end)
	self:AddMenuSlider("Fade % When Mouse Out", nil, 0, 100, 1, function()
		return self:GetOrDefault( .5, self.Settings["UIMouseOutAlpha"] ) * 100
	end, function(val)
		self.Settings["UIMouseOutAlpha"] = (val / 100)
		if WYK_WarTools_StrategyUI ~= nil then
			WYK_WarTools_StrategyUI:SetOutAlpha( val / 100 )
			WYK_WarTools_StrategyUI.Backdrop:SetAlpha( val / 100 )
		end
	end)
	self:AddMenuSlider("Fade % When Mouse Over", nil, 0, 100, 1, function()
		return self:GetOrDefault( .85, self.Settings["UIMouseInAlpha"] ) * 100
	end, function(val)
		self.Settings["UIMouseInAlpha"] = (val / 100)
		if WYK_WarTools_StrategyUI ~= nil then
			WYK_WarTools_StrategyUI:SetInAlpha( val / 100 )
		end
	end)
end

WYK_WarTools.Initialize = function( self )
	self:SlashCommand("wt", self.CommandLine)
	self:SlashCommand("warcommand", self.ToggleCommand)
	
	self.UserInterface.CreateStrategyFrame()
end

REGISTER_WYKKYD_FACTORY( 
	WYK_WarTools, false, true, 
	function( self ) self:LoadSavedVariables() end, 
	function( self ) self:LoadSettingsMenu() end, 
	function( self ) self:Initialize() end 
)